// FEC_XPOS_LED_ConsoleTester.cpp : wqDxε{iJIC
//

#include "stdafx.h"
#include "stdlib.h"
#include <iostream>
#include <windows.h>
#include "fec_xpos_led_dll.h"

typedef bool(*pfInitFunc)(void);
typedef bool(*pfDeInitFunc)(void);
typedef bool(*pfSetLEDFunc)(BYTE);

pfInitFunc             pfInit;
pfDeInitFunc           pfDeInit;
pfSetLEDFunc           pfSetLED;

HINSTANCE hLibrary;

int InitDll(void)
{

	hLibrary = LoadLibrary(L"fec_xpos_led_dll_32.dll");

	if (!hLibrary)
	{
		//std::cout << "Failed To Load Library" << std::endl;
		fprintf(stderr, "Failed To Load FEC_XPOS_LED_Dll Library.\n");
		return 1;
	}
	else
	{
		fprintf(stderr, "Load FEC_XPOS_LED_Dll Library successfully.\n");

		pfInit = (pfInitFunc)GetProcAddress(hLibrary, "Init");
		pfDeInit = (pfDeInitFunc)GetProcAddress(hLibrary, "DeInit");
		pfSetLED = (pfSetLEDFunc)GetProcAddress(hLibrary, "SetLED");

        Sleep(300);

        pfInit();

	    return 0;
	}
}

void DeInitDll(void)
{
    if(true == pfDeInit())
        fprintf(stderr, "Success To Unload Library.\n");
    else
        fprintf(stderr, "Failed To Unload Library.\n");

    Sleep(300);

	FreeLibrary(hLibrary);
}

int main(int argc, char *argv[])
{
    if(1 == InitDll())
    {
        fprintf(stderr, "Failed To Load Library.\n");
        return 1;
    }

    if(argc == 2)
    {
        if((strcmp(argv[1], "OFF") == 0) || (strcmp(argv[1], "off") == 0))
        {
            pfSetLED(COLOR_LED_OFF);
        }
        else if((strcmp(argv[1], "RED") == 0) || (strcmp(argv[1], "red") == 0))
        {
            pfSetLED(COLOR_RED);
        }
        else if((strcmp(argv[1], "GREEN") == 0) || (strcmp(argv[1], "green") == 0))
        {
            pfSetLED(COLOR_GREEN);
        }
        else if((strcmp(argv[1], "BLUE") == 0) || (strcmp(argv[1], "blue") == 0))
        {
            pfSetLED(COLOR_BLUE);
        }
        else if((strcmp(argv[1], "WHITE") == 0) || (strcmp(argv[1], "white") == 0))
        {
            pfSetLED(COLOR_WHITE);
        }
        else if((strcmp(argv[1], "CB") == 0) || (strcmp(argv[1], "cb") == 0))
        {
            pfSetLED(COLOR_CYAN_BLUE);
        }
        else if((strcmp(argv[1], "YELLOW") == 0) || (strcmp(argv[1], "yellow") == 0))
        {
            pfSetLED(COLOR_YELLOW);
        }
        else if((strcmp(argv[1], "PURPLE") == 0) || (strcmp(argv[1], "purple") == 0))
        {
            pfSetLED(COLOR_PURPLE);
        }
        else
        {
            std::cout << "FEC XPOS IOBOARD Test incorrect parameter, use following:" << std::endl;
            std::cout << "OFF" << std::endl;
            std::cout << "RED" << std::endl;
            std::cout << "GREEN" << std::endl;
            std::cout << "BLUE" << std::endl;
            std::cout << "WHITE" << std::endl;
            std::cout << "CB" << std::endl;
            std::cout << "YELLOW" << std::endl;
            std::cout << "PURPLE" << std::endl;
        }
    }
    else
    {
        std::cout << "FEC XPOS IOBOARD Test incorrect parameter, use following:" << std::endl;
        std::cout << "OFF" << std::endl;
        std::cout << "RED" << std::endl;
        std::cout << "GREEN" << std::endl;
        std::cout << "BLUE" << std::endl;
        std::cout << "WHITE" << std::endl;
        std::cout << "CB" << std::endl;
        std::cout << "YELLOW" << std::endl;
        std::cout << "PURPLE" << std::endl;
    }

    DeInitDll();
    
    return 0;
}

