; example1.nsi
;
; This script is perhaps one of the simplest NSIs you can make. All of the
; optional settings are left to their default settings. The installer simply 
; prompts the user asking them where to install, and drops a copy of example1.nsi
; there. 
;--------------------------------
;Include Modern UI

!include "MUI2.nsh"
!include "x64.nsh"
;--------------------------------

; The name of the installer
Name "FEC XPOS LED SDK"

; The file to write
; OutFile "FECCashDrawerSDKSETUP_Silent.exe"
OutFile "FEC_XPOS_LED_SDK_SETUP.exe"

; The default installation directory
InstallDir $PROGRAMFILES\FEC\XPOS_LED_SDK


;InstallDirRegKey HKLM "Software\FEC" "Install_Dir"

; Request application privileges for Windows Vista
RequestExecutionLevel admin

;--------------------------------
;Variables

  Var StartMenuFolder

;--------------------------------
;Interface Settings

  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_RIGHT
  !define MUI_ICON "${NSISDIR}\Contrib\MUI Orange Vista Theme\Clean\installer.ico"
  !define MUI_UNICON "${NSISDIR}\Contrib\MUI Orange Vista Theme\Clean\uninstaller.ico"
  !define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\Clean\header-r.bmp" ; optional
  !define MUI_HEADERIMAGE_UNBITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\Clean\header-r-un.bmp"
  ;!define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\Clean\wizard.bmp"
  ;!define MUI_UNWELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\Clean\wizard-un.bmp"
  !define MUI_ABORTWARNING

;--------------------------------
;Language Selection Dialog Settings

  ;Remember the installer language
  !define MUI_LANGDLL_REGISTRY_ROOT "HKLM" 
  !define MUI_LANGDLL_REGISTRY_KEY "Software\FEC" 
  !define MUI_LANGDLL_REGISTRY_VALUENAME "Installer Language"

;--------------------------------

; Pages

  ;!insertmacro MUI_PAGE_DIRECTORY
  
  !insertmacro MUI_PAGE_WELCOME

  ;Start Menu Folder Page Configuration
  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKLM" 
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\FEC" 
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "Start Menu Folder"

  ;!insertmacro MUI_PAGE_STARTMENU Application $StartMenuFolder

  !insertmacro MUI_PAGE_INSTFILES

  ;!insertmacro MUI_PAGE_FINISH
  
  ;!insertmacro MUI_UNPAGE_WELCOME
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  ;!insertmacro MUI_UNPAGE_FINISH

;--------------------------------
;Languages

  !insertmacro MUI_LANGUAGE "English" ;first language is the default language
  ;!insertmacro MUI_LANGUAGE "French"
  ;!insertmacro MUI_LANGUAGE "German"
  ;!insertmacro MUI_LANGUAGE "Spanish"
  ;!insertmacro MUI_LANGUAGE "SpanishInternational"
  ;!insertmacro MUI_LANGUAGE "SimpChinese"
  ;!insertmacro MUI_LANGUAGE "TradChinese"
  ;!insertmacro MUI_LANGUAGE "Japanese"
  ;!insertmacro MUI_LANGUAGE "Korean"
  ;!insertmacro MUI_LANGUAGE "Italian"
  ;!insertmacro MUI_LANGUAGE "Dutch"
  ;!insertmacro MUI_LANGUAGE "Danish"
  ;!insertmacro MUI_LANGUAGE "Swedish"
  ;!insertmacro MUI_LANGUAGE "Norwegian"
  ;!insertmacro MUI_LANGUAGE "NorwegianNynorsk"
  ;!insertmacro MUI_LANGUAGE "Finnish"
  ;!insertmacro MUI_LANGUAGE "Greek"
  ;!insertmacro MUI_LANGUAGE "Russian"
  ;!insertmacro MUI_LANGUAGE "Portuguese"
  ;!insertmacro MUI_LANGUAGE "PortugueseBR"
  ;!insertmacro MUI_LANGUAGE "Polish"
  ;!insertmacro MUI_LANGUAGE "Ukrainian"
  ;!insertmacro MUI_LANGUAGE "Czech"
  ;!insertmacro MUI_LANGUAGE "Slovak"
  ;!insertmacro MUI_LANGUAGE "Croatian"
  ;!insertmacro MUI_LANGUAGE "Bulgarian"
  ;!insertmacro MUI_LANGUAGE "Hungarian"
  ;!insertmacro MUI_LANGUAGE "Thai"
  ;!insertmacro MUI_LANGUAGE "Romanian"
  ;!insertmacro MUI_LANGUAGE "Latvian"
  ;!insertmacro MUI_LANGUAGE "Macedonian"
  ;!insertmacro MUI_LANGUAGE "Estonian"
  ;!insertmacro MUI_LANGUAGE "Turkish"
  ;!insertmacro MUI_LANGUAGE "Lithuanian"
  ;!insertmacro MUI_LANGUAGE "Slovenian"
  ;!insertmacro MUI_LANGUAGE "Serbian"
  ;!insertmacro MUI_LANGUAGE "SerbianLatin"
  ;!insertmacro MUI_LANGUAGE "Arabic"
  ;!insertmacro MUI_LANGUAGE "Farsi"
  ;!insertmacro MUI_LANGUAGE "Hebrew"
  ;!insertmacro MUI_LANGUAGE "Indonesian"
  ;!insertmacro MUI_LANGUAGE "Mongolian"
  ;!insertmacro MUI_LANGUAGE "Luxembourgish"
  ;!insertmacro MUI_LANGUAGE "Albanian"
  ;!insertmacro MUI_LANGUAGE "Breton"
  ;!insertmacro MUI_LANGUAGE "Belarusian"
  ;!insertmacro MUI_LANGUAGE "Icelandic"
  ;!insertmacro MUI_LANGUAGE "Malay"
  ;!insertmacro MUI_LANGUAGE "Bosnian"
  ;!insertmacro MUI_LANGUAGE "Kurdish"
  ;!insertmacro MUI_LANGUAGE "Irish"
  ;!insertmacro MUI_LANGUAGE "Uzbek"
  ;!insertmacro MUI_LANGUAGE "Galician"
  ;!insertmacro MUI_LANGUAGE "Afrikaans"
  ;!insertmacro MUI_LANGUAGE "Catalan"

;--------------------------------
;Reserve Files
  
  ;If you are using solid compression, files that are required before
  ;the actual installation should be stored first in the data block,
  ;because this will make your installer start faster.
  
  !insertmacro MUI_RESERVEFILE_LANGDLL

;--------------------------------


;--------------------------------
;Version Information

  VIProductVersion "1.0.0.6"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "FEC XPOS LED SDK"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Support Win10 IOT 64bit OS"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Firich enterprises co.,ltd."
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalTrademarks" "TFirich enterprises co.,ltd."
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Firich enterprises co.,ltd."
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "FEC XPOS LED SDK"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "1.0.0.1"

;--------------------------------

; The stuff to install
;No components page, name is not important
Section "" ;Section1


  ; Set output path to the installation directory.
  SetOutPath $INSTDIR

  ;FEC Cash Drawer files
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\fec_xpos_led_dll_32.dll'
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\fec_xpos_led_dll_64.dll'
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\FEC_XPOS_LED_Utility.exe'
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\FEC_XPOS_LED_ConsoleTester.exe'
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\WinIo32.dll'
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\WinIo32.sys'
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\WinIo64.dll'
  File 'C:\Users\elliot.ling\Documents\Visual Studio 2015\Projects\FEC_XPOS_LED\FEC_XPOS_LED_Utility\bin\Release\WinIo64.sys'
   
  ;CreateDirectory $INSTDIR\log
 
  ;CopyFiles /SILENT "D:\Temp3\FECService\FECService.exe" "D:\Temp3\FECService\FECService.dll"
  ;ExecWait '"$INSTDIR\install.bat"'


  ; Write the installation path into the registry
  ; Write the uninstall keys for Windows
  ;WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FEC" "DisplayName" "FEC Service"
  ;WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FEC" "UninstallString" '"$INSTDIR\uninstall.exe"'
  ;WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FEC" "NoModify" 1
  ;WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FEC" "NoRepair" 1

  ;DeleteRegKey HKLM "SOFTWARE\FEC"
  ;WriteRegStr HKLM "SOFTWARE\FEC\" "" ""
  ;WriteRegStr HKLM SOFTWARE\FEC "Install_Dir" "$INSTDIR"
  ;WriteRegStr HKLM "SOFTWARE\FEC\" "ServiceInterval" "3000"
  ;WriteRegStr HKLM "SOFTWARE\FEC\" "DebugEnable" "1"
  ;WriteRegStr HKLM "SOFTWARE\FEC\" "RunFile" "/c C:\FEC\Run.bat"  


  WriteUninstaller "$INSTDIR\Uninstall.exe"
  ;ExecWait '"$INSTDIR\FECIOsetup.exe"'
  ;ExecWait '"$INSTDIR\FECIOsetup.exe"' $0
  ;DetailPrint "FEC IO Install $0"
  ;Sleep 1000


  ;Delete "$INSTDIR\install.bat"

  ;!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    
    ;Create shortcuts
    ;CreateDirectory "$SMPROGRAMS\$StartMenuFolder"
    ;CreateShortCut "$SMPROGRAMS\$StartMenuFolder\auto_run_FECAgentShowMesssage.lnk" "$INSTDIR\auto_run_FECAgentShowMesssage.bat"
    ;CreateShortCut "$SMPROGRAMS\$StartMenuFolder\FECOPOSKBSetup.lnk" "$INSTDIR\FECOPOSKBSetup.exe"
    ;CreateShortCut "$SMPROGRAMS\$StartMenuFolder\FECOPOSLDSetup.lnk" "$INSTDIR\FECOPOSLDSetup.exe"
    ;CreateShortCut "$SMPROGRAMS\$StartMenuFolder\CashDrawerDemo.lnk" "$INSTDIR\CashDrawerDemo.exe"
    ;CreateShortCut "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
    ;CreateShortCut "$SMSTARTUP\auto_run_FECAgentShowMesssage.lnk" "$INSTDIR\auto_run_FECAgentShowMesssage.bat"
  
  ;!insertmacro MUI_STARTMENU_WRITE_END

SectionEnd ; end the section

;--------------------------------
;Descriptions

  ;Language strings
;  LangString DESC_Section1 ${LANG_ENGLISH} "FEC OPOS Install Section."

  ;Assign language strings to sections
;  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
;    !insertmacro MUI_DESCRIPTION_TEXT ${Section1} $(DESC_Section1)
;  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------

;Installer Functions

Function .onInit

  !insertmacro MUI_LANGDLL_DISPLAY
;  SetSilent silent
FunctionEnd

;--------------------------------
; Uninstaller

Section "Uninstall"

  MessageBox MB_YESNO|MB_ICONQUESTION "Would you like to uninstall the FEC XPOS LED SDK?" IDNO NoDelete
  
  ; Remove registry keys
  ;DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FEC"
  ;DeleteRegKey HKLM "SOFTWARE\FEC"

  ;ExecWait '"$INSTDIR\FECIORemove.exe"'
  ;ExecWait '"$INSTDIR\FECIORemove.exe"' $0
  ;DetailPrint "FEC IO Uninstall $0"
  ;Sleep 1000



  ;UnRegDLL "$INSTDIR\CRSIT8XCD.dll"
  ;UnRegDLL "$INSTDIR\CRSIT8XCD2.dll"
  ;UnRegDLL "$INSTDIR\FECOPOSKB.dll"
  ;UnRegDLL "$INSTDIR\FECOPOSLD.dll"
  ;Sleep 2000

  ; Remove files and uninstaller
  Delete $INSTDIR\*.*

  ; Remove shortcuts, if any
  ;Delete "$SMPROGRAMS\Example2\*.*"

  ; Remove directories used
  ;RMDir "$SMPROGRAMS\Example2"
  RMDir "$INSTDIR"

  !insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuFolder

  ;Delete "$SMPROGRAMS\$StartMenuFolder\FECOPOSCDSetup.lnk"
  ;Delete "$SMPROGRAMS\$StartMenuFolder\FECOPOSKBSetup.lnk"
  ;Delete "$SMPROGRAMS\$StartMenuFolder\FECOPOSLDSetup.lnk"
  ;Delete "$SMPROGRAMS\$StartMenuFolder\CashDrawerDemo.lnk"
  ;Delete "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk"
  ;RMDir "$SMPROGRAMS\$StartMenuFolder"

  NoDelete:

SectionEnd

;--------------------------------
;Uninstaller Functions

Function un.onInit

  !insertmacro MUI_UNGETLANGUAGE
  
FunctionEnd

;--------------------------------

;Function .onInstSuccess
;  MessageBox MB_YESNO|MB_ICONQUESTION "Do you wish to reboot the system?" IDNO +2
;  Reboot
;FunctionEnd
